package test;

import java.util.HashMap;
import java.util.Map;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Persistence;
import javax.persistence.Query;

public class Main {

    private static EntityManagerFactory emf;

    public static void main(String[] args) {
        Map<String, String> properties = new HashMap<String, String>();
        properties.put("javax.persistence.jdbc.user", "admin");
        properties.put("javax.persistence.jdbc.password", "admin");
        emf = Persistence.createEntityManagerFactory("objectdb:$objectdb/db/test.tmp;drop", properties);
        EntityManager em = emf.createEntityManager();

        //Prepare DB
        em.getTransaction().begin();
        User test = new User();
        test.setPassword("password");
        test.setUsername("username");
        em.persist(test);
        em.getTransaction().commit();
        em.close();

        //Start test
        User u = getUserByName("username");
        System.out.println(u.getUsername());
    }

    public static User getUserByName(String name) {
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        Query q = em.createQuery("SELECT u FROM User u WHERE u.username = :uname");
        q.setParameter("uname", name);
        User u = (User) q.getSingleResult();
        em.getTransaction().commit();
        em.close();
        return u;
    }

    @Entity
    public static class User {

        private Long id;
        private String username;
        private String password;

        @GeneratedValue
        @Id
        public Long getId() {
            return id;
        }

        public void setId(Long id) {
            this.id = id;
        }

        public String getPassword() {
            return password;
        }

        public void setPassword(String password) {
            this.password = password;
        }

        @Column(unique = true)
        public String getUsername() {
            return username;
        }

        public void setUsername(String username) {
            this.username = username;
        }

    }
}
